/**
 * NOTE: This class is auto generated by the swagger code generator program (2.4.21).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package mx.sidlors.dvd.rental.api;

import  mx.sidlors.dvd.rental.model.Payment;
import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
@javax.annotation.Generated(value = "io.swagger.codegen.languages.SpringCodegen", date = "2021-07-21T02:33:33.560Z")

@Validated
@Api(value = "payment", description = "the payment API")
@RequestMapping(value = "")
public interface PaymentApi {

    @ApiOperation(value = "", nickname = "paymentDelete", notes = "", tags={ "payment", })
    @ApiResponses(value = { 
        @ApiResponse(code = 204, message = "No Content") })
    @RequestMapping(value = "/payment",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.DELETE)
    ResponseEntity<Void> paymentDelete(@ApiParam(value = "") @Valid @RequestParam(value = "payment_id", required = false) String paymentId,@ApiParam(value = "") @Valid @RequestParam(value = "customer_id", required = false) String customerId,@ApiParam(value = "") @Valid @RequestParam(value = "staff_id", required = false) String staffId,@ApiParam(value = "") @Valid @RequestParam(value = "rental_id", required = false) String rentalId,@ApiParam(value = "") @Valid @RequestParam(value = "amount", required = false) String amount,@ApiParam(value = "") @Valid @RequestParam(value = "payment_date", required = false) String paymentDate,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "paymentGet", notes = "", response = Payment.class, responseContainer = "List", tags={ "payment", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = Payment.class, responseContainer = "List"),
        @ApiResponse(code = 206, message = "Partial Content") })
    @RequestMapping(value = "/payment",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.GET)
    ResponseEntity<List<Payment>> paymentGet(@ApiParam(value = "") @Valid @RequestParam(value = "payment_id", required = false) String paymentId,@ApiParam(value = "") @Valid @RequestParam(value = "customer_id", required = false) String customerId,@ApiParam(value = "") @Valid @RequestParam(value = "staff_id", required = false) String staffId,@ApiParam(value = "") @Valid @RequestParam(value = "rental_id", required = false) String rentalId,@ApiParam(value = "") @Valid @RequestParam(value = "amount", required = false) String amount,@ApiParam(value = "") @Valid @RequestParam(value = "payment_date", required = false) String paymentDate,@ApiParam(value = "Filtering Columns") @Valid @RequestParam(value = "select", required = false) String select,@ApiParam(value = "Ordering") @Valid @RequestParam(value = "order", required = false) String order,@ApiParam(value = "Limiting and Pagination" ) @RequestHeader(value="Range", required=false) String range,@ApiParam(value = "Limiting and Pagination" , defaultValue="items") @RequestHeader(value="Range-Unit", required=false) String rangeUnit,@ApiParam(value = "Limiting and Pagination") @Valid @RequestParam(value = "offset", required = false) String offset,@ApiParam(value = "Limiting and Pagination") @Valid @RequestParam(value = "limit", required = false) String limit,@ApiParam(value = "Preference" , allowableValues="count=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "paymentPatch", notes = "", tags={ "payment", })
    @ApiResponses(value = { 
        @ApiResponse(code = 204, message = "No Content") })
    @RequestMapping(value = "/payment",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.PATCH)
    ResponseEntity<Void> paymentPatch(@ApiParam(value = "") @Valid @RequestParam(value = "payment_id", required = false) String paymentId,@ApiParam(value = "") @Valid @RequestParam(value = "customer_id", required = false) String customerId,@ApiParam(value = "") @Valid @RequestParam(value = "staff_id", required = false) String staffId,@ApiParam(value = "") @Valid @RequestParam(value = "rental_id", required = false) String rentalId,@ApiParam(value = "") @Valid @RequestParam(value = "amount", required = false) String amount,@ApiParam(value = "") @Valid @RequestParam(value = "payment_date", required = false) String paymentDate,@ApiParam(value = "payment"  )  @Valid @RequestBody Payment payment,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "paymentPost", notes = "", tags={ "payment", })
    @ApiResponses(value = { 
        @ApiResponse(code = 201, message = "Created") })
    @RequestMapping(value = "/payment",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.POST)
    ResponseEntity<Void> paymentPost(@ApiParam(value = "payment"  )  @Valid @RequestBody Payment payment,@ApiParam(value = "Filtering Columns") @Valid @RequestParam(value = "select", required = false) String select,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);

}
